/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractDropDownMenu;

/**
 * 
 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIDropDownMenu extends AbstractDropDownMenu
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.DropDownMenu";

    public static final String COMPONENT_FAMILY="org.richfaces.DropDownMenu";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIDropDownMenu() {
        super();
        setRendererType("org.richfaces.DropDownMenuRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "grouphide",
        "keyup",
        "mousedown",
        "itemclick",
        "click",
        "mouseover",
        "mousemove",
        "keydown",
        "mouseout",
        "groupshow",
        "keypress",
        "dblclick",
        "hide",
        "show",
        "mouseup"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        disabled,
        hideDelay,
        mode,
        ongrouphide,
        ongroupshow,
        onhide,
        onitemclick,
        onshow,
        popupWith,
        showDelay,
        showEvent

    }


 
    public boolean isDisabled() {
        return (Boolean) getStateHelper().eval(Properties.disabled, false);
    }
    
    public void setDisabled(boolean disabled) {
        getStateHelper().put(Properties.disabled, disabled);
    }

 
    public int getHideDelay() {
        return (Integer) getStateHelper().eval(Properties.hideDelay, 300);
    }
    
    public void setHideDelay(int hideDelay) {
        getStateHelper().put(Properties.hideDelay, hideDelay);
    }

 
    public String getMode() {
        return (String) getStateHelper().eval(Properties.mode, "server");
    }
    
    public void setMode(String mode) {
        getStateHelper().put(Properties.mode, mode);
    }

 
    public String getOngrouphide() {
        return (String) getStateHelper().eval(Properties.ongrouphide);
    }
    
    public void setOngrouphide(String ongrouphide) {
        getStateHelper().put(Properties.ongrouphide, ongrouphide);
    }

 
    public String getOngroupshow() {
        return (String) getStateHelper().eval(Properties.ongroupshow);
    }
    
    public void setOngroupshow(String ongroupshow) {
        getStateHelper().put(Properties.ongroupshow, ongroupshow);
    }

 
    public String getOnhide() {
        return (String) getStateHelper().eval(Properties.onhide);
    }
    
    public void setOnhide(String onhide) {
        getStateHelper().put(Properties.onhide, onhide);
    }

 
    public String getOnitemclick() {
        return (String) getStateHelper().eval(Properties.onitemclick);
    }
    
    public void setOnitemclick(String onitemclick) {
        getStateHelper().put(Properties.onitemclick, onitemclick);
    }

 
    public String getOnshow() {
        return (String) getStateHelper().eval(Properties.onshow);
    }
    
    public void setOnshow(String onshow) {
        getStateHelper().put(Properties.onshow, onshow);
    }

 
    public int getPopupWith() {
        return (Integer) getStateHelper().eval(Properties.popupWith, 250);
    }
    
    public void setPopupWith(int popupWith) {
        getStateHelper().put(Properties.popupWith, popupWith);
    }

 
    public int getShowDelay() {
        return (Integer) getStateHelper().eval(Properties.showDelay, 50);
    }
    
    public void setShowDelay(int showDelay) {
        getStateHelper().put(Properties.showDelay, showDelay);
    }

 
    public String getShowEvent() {
        return (String) getStateHelper().eval(Properties.showEvent);
    }
    
    public void setShowEvent(String showEvent) {
        getStateHelper().put(Properties.showEvent, showEvent);
    }

}