/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractFileUpload;

/**
 *  @author Konstantin Mishin
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIFileUpload extends AbstractFileUpload
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.FileUpload";

    public static final String COMPONENT_FAMILY="org.richfaces.FileUpload";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIFileUpload() {
        super();
        setRendererType("org.richfaces.FileUploadRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "uploadcomplete",
        "keypress",
        "mousedown",
        "keyup",
        "dblclick",
        "click",
        "mouseover",
        "filesubmit",
        "mousemove",
        "mouseout",
        "keydown",
        "mouseup"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        acceptedTypes,
        enabled,
        noDuplicate,
        onfilesubmit,
        onuploadcomplete

    }


 
    public String getAcceptedTypes() {
        return (String) getStateHelper().eval(Properties.acceptedTypes);
    }
    
    public void setAcceptedTypes(String acceptedTypes) {
        getStateHelper().put(Properties.acceptedTypes, acceptedTypes);
    }

 
    public boolean isEnabled() {
        return (Boolean) getStateHelper().eval(Properties.enabled, true);
    }
    
    public void setEnabled(boolean enabled) {
        getStateHelper().put(Properties.enabled, enabled);
    }

 
    public boolean isNoDuplicate() {
        return (Boolean) getStateHelper().eval(Properties.noDuplicate, false);
    }
    
    public void setNoDuplicate(boolean noDuplicate) {
        getStateHelper().put(Properties.noDuplicate, noDuplicate);
    }

 
    public String getOnfilesubmit() {
        return (String) getStateHelper().eval(Properties.onfilesubmit);
    }
    
    public void setOnfilesubmit(String onfilesubmit) {
        getStateHelper().put(Properties.onfilesubmit, onfilesubmit);
    }

 
    public String getOnuploadcomplete() {
        return (String) getStateHelper().eval(Properties.onuploadcomplete);
    }
    
    public void setOnuploadcomplete(String onuploadcomplete) {
        getStateHelper().put(Properties.onuploadcomplete, onuploadcomplete);
    }

}