/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractMenuGroup;

/**
 * 
 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIMenuGroup extends AbstractMenuGroup
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.MenuGroup";

    public static final String COMPONENT_FAMILY="org.richfaces.DropDownMenu";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIMenuGroup() {
        super();
        setRendererType("org.richfaces.MenuGroupRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "keypress",
        "mousedown",
        "keyup",
        "dblclick",
        "click",
        "hide",
        "show",
        "mouseover",
        "mousemove",
        "mouseout",
        "keydown",
        "mouseup"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        disabled,
        icon,
        iconDisabled,
        iconFolder,
        iconFolderDisabled,
        label,
        onhide,
        onshow,
        style,
        styleClass

    }


 
    public boolean isDisabled() {
        return (Boolean) getStateHelper().eval(Properties.disabled, false);
    }
    
    public void setDisabled(boolean disabled) {
        getStateHelper().put(Properties.disabled, disabled);
    }

 
    public String getIcon() {
        return (String) getStateHelper().eval(Properties.icon);
    }
    
    public void setIcon(String icon) {
        getStateHelper().put(Properties.icon, icon);
    }

 
    public String getIconDisabled() {
        return (String) getStateHelper().eval(Properties.iconDisabled);
    }
    
    public void setIconDisabled(String iconDisabled) {
        getStateHelper().put(Properties.iconDisabled, iconDisabled);
    }

 
    public String getIconFolder() {
        return (String) getStateHelper().eval(Properties.iconFolder);
    }
    
    public void setIconFolder(String iconFolder) {
        getStateHelper().put(Properties.iconFolder, iconFolder);
    }

 
    public String getIconFolderDisabled() {
        return (String) getStateHelper().eval(Properties.iconFolderDisabled);
    }
    
    public void setIconFolderDisabled(String iconFolderDisabled) {
        getStateHelper().put(Properties.iconFolderDisabled, iconFolderDisabled);
    }

 
    public String getLabel() {
        return (String) getStateHelper().eval(Properties.label);
    }
    
    public void setLabel(String label) {
        getStateHelper().put(Properties.label, label);
    }

 
    public String getOnhide() {
        return (String) getStateHelper().eval(Properties.onhide);
    }
    
    public void setOnhide(String onhide) {
        getStateHelper().put(Properties.onhide, onhide);
    }

 
    public String getOnshow() {
        return (String) getStateHelper().eval(Properties.onshow);
    }
    
    public void setOnshow(String onshow) {
        getStateHelper().put(Properties.onshow, onshow);
    }

 
    public String getStyle() {
        return (String) getStateHelper().eval(Properties.style);
    }
    
    public void setStyle(String style) {
        getStateHelper().put(Properties.style, style);
    }

 
    public String getStyleClass() {
        return (String) getStateHelper().eval(Properties.styleClass);
    }
    
    public void setStyleClass(String styleClass) {
        getStateHelper().put(Properties.styleClass, styleClass);
    }

}