/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractToolbar;

/**
 * 
 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIToolbar extends AbstractToolbar
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.Toolbar";

    public static final String COMPONENT_FAMILY="org.richfaces.Toolbar";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIToolbar() {
        super();
        setRendererType("org.richfaces.ToolbarRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "itemkeyup",
        "itemclick",
        "itemdblclick",
        "itemkeydown",
        "itemmousedown",
        "itemkeypress",
        "itemmouseup",
        "itemmouseover",
        "itemmouseout",
        "itemmousemove"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        height,
        itemClass,
        itemSeparator,
        itemStyle,
        onitemclick,
        onitemdblclick,
        onitemkeydown,
        onitemkeypress,
        onitemkeyup,
        onitemmousedown,
        onitemmousemove,
        onitemmouseout,
        onitemmouseover,
        onitemmouseup,
        width

    }


 
    public String getHeight() {
        return (String) getStateHelper().eval(Properties.height);
    }
    
    public void setHeight(String height) {
        getStateHelper().put(Properties.height, height);
    }

 
    public String getItemClass() {
        return (String) getStateHelper().eval(Properties.itemClass);
    }
    
    public void setItemClass(String itemClass) {
        getStateHelper().put(Properties.itemClass, itemClass);
    }

 
    public String getItemSeparator() {
        return (String) getStateHelper().eval(Properties.itemSeparator);
    }
    
    public void setItemSeparator(String itemSeparator) {
        getStateHelper().put(Properties.itemSeparator, itemSeparator);
    }

 
    public String getItemStyle() {
        return (String) getStateHelper().eval(Properties.itemStyle);
    }
    
    public void setItemStyle(String itemStyle) {
        getStateHelper().put(Properties.itemStyle, itemStyle);
    }

 
    public String getOnitemclick() {
        return (String) getStateHelper().eval(Properties.onitemclick);
    }
    
    public void setOnitemclick(String onitemclick) {
        getStateHelper().put(Properties.onitemclick, onitemclick);
    }

 
    public String getOnitemdblclick() {
        return (String) getStateHelper().eval(Properties.onitemdblclick);
    }
    
    public void setOnitemdblclick(String onitemdblclick) {
        getStateHelper().put(Properties.onitemdblclick, onitemdblclick);
    }

 
    public String getOnitemkeydown() {
        return (String) getStateHelper().eval(Properties.onitemkeydown);
    }
    
    public void setOnitemkeydown(String onitemkeydown) {
        getStateHelper().put(Properties.onitemkeydown, onitemkeydown);
    }

 
    public String getOnitemkeypress() {
        return (String) getStateHelper().eval(Properties.onitemkeypress);
    }
    
    public void setOnitemkeypress(String onitemkeypress) {
        getStateHelper().put(Properties.onitemkeypress, onitemkeypress);
    }

 
    public String getOnitemkeyup() {
        return (String) getStateHelper().eval(Properties.onitemkeyup);
    }
    
    public void setOnitemkeyup(String onitemkeyup) {
        getStateHelper().put(Properties.onitemkeyup, onitemkeyup);
    }

 
    public String getOnitemmousedown() {
        return (String) getStateHelper().eval(Properties.onitemmousedown);
    }
    
    public void setOnitemmousedown(String onitemmousedown) {
        getStateHelper().put(Properties.onitemmousedown, onitemmousedown);
    }

 
    public String getOnitemmousemove() {
        return (String) getStateHelper().eval(Properties.onitemmousemove);
    }
    
    public void setOnitemmousemove(String onitemmousemove) {
        getStateHelper().put(Properties.onitemmousemove, onitemmousemove);
    }

 
    public String getOnitemmouseout() {
        return (String) getStateHelper().eval(Properties.onitemmouseout);
    }
    
    public void setOnitemmouseout(String onitemmouseout) {
        getStateHelper().put(Properties.onitemmouseout, onitemmouseout);
    }

 
    public String getOnitemmouseover() {
        return (String) getStateHelper().eval(Properties.onitemmouseover);
    }
    
    public void setOnitemmouseover(String onitemmouseover) {
        getStateHelper().put(Properties.onitemmouseover, onitemmouseover);
    }

 
    public String getOnitemmouseup() {
        return (String) getStateHelper().eval(Properties.onitemmouseup);
    }
    
    public void setOnitemmouseup(String onitemmouseup) {
        getStateHelper().put(Properties.onitemmouseup, onitemmouseup);
    }

 
    public String getWidth() {
        return (String) getStateHelper().eval(Properties.width, "100%");
    }
    
    public void setWidth(String width) {
        getStateHelper().put(Properties.width, width);
    }

}