/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractTreeModelRecursiveAdaptor;

/**
 *  @author Nick Belaevski
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UITreeModelRecursiveAdaptor extends AbstractTreeModelRecursiveAdaptor
        {

    public static final String COMPONENT_TYPE="org.richfaces.TreeModelRecursiveAdaptor";

    public static final String COMPONENT_FAMILY="org.richfaces.TreeModelRecursiveAdaptor";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }





    protected static enum Properties {
        nodes,
        recursionOrder,
        roots

    }


 
    public Object getNodes() {
        return (Object) getStateHelper().eval(Properties.nodes);
    }
    
    public void setNodes(Object nodes) {
        getStateHelper().put(Properties.nodes, nodes);
    }

 
    public String getRecursionOrder() {
        return (String) getStateHelper().eval(Properties.recursionOrder, "first");
    }
    
    public void setRecursionOrder(String recursionOrder) {
        getStateHelper().put(Properties.recursionOrder, recursionOrder);
    }

 
    public Object getRoots() {
        return (Object) getStateHelper().eval(Properties.roots);
    }
    
    public void setRoots(Object roots) {
        getStateHelper().put(Properties.roots, roots);
    }

}